/*
 * Created on 20.03.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package points;

import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.ListModel;

public class PointModel extends DefaultListModel implements ListModel {
	
	List<Point> selected = new ArrayList<Point>(); 
	
	List<PointsListener> listeners = new ArrayList<PointsListener>(); 
	

	public void add(Point p) {
		addElement(p); 
		firePointEvent(p); 
    } 
	
	public void removeLast() {
		if (!isEmpty()) {
			Point p = (Point) get(size()-1); 
			removeElementAt(size()-1); 
			firePointEvent(p); 
		}
	}
	
	public void remove(Point p) {
		removeElement(p); 
		firePointEvent(p); 
	}
	
	private void firePointEvent(Point p) {
		for (PointsListener propCL: listeners) {
			propCL.pointChanged(new PointEvent(this, p)); 
		}		
	}

       
	public Point[] getPoints() {
		Point[] points = new Point[size()]; 
		for (int i = 0; i < size(); i++) {
			points[i] = (Point)getElementAt(i); 
		}
		return points; 
	}

	public void addPointsListener(PointsListener l) {
		listeners.add(l);
	}

	public void removePointsListener(PointsListener l) {
		listeners.remove(l); 
	}

	// selected 
	
	public void setSelected(Point p) {
		selected.add(p); 
	}
     
	public Point[] getSelected() {
		return selected.toArray(new Point[0]);
	}
	
	public void clearSelected() {
		selected.clear(); 
	}

	public boolean isSelected(Point p) {
		return selected.contains(p);
	}
	
}
