/*
 * Created on 20.03.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package points;

import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JPanel;

public class PointPanel extends JPanel implements PointsListener {
	
	PointModel pointsModel; 
	
	public PointPanel(PointModel model) {
		this.pointsModel = model; 
		pointsModel.addPointsListener(this); 
		this.addMouseListener(new MouseClickHandler()); 
	}
	

    /* (non-Javadoc)
     * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
     */
    protected void paintComponent(Graphics g) {
    	super.paintComponent(g); 
    	for (Point p: pointsModel.getPoints()) {
    		if (pointsModel.isSelected(p)) {
    			p.draw(g, true); 
    		} else {
    			p.draw(g);
    		}
     	}
    }

    public void pointChanged(PointEvent event) {
       repaint(); 
    }
    
    class MouseClickHandler implements MouseListener {
    	
    	public void mouseClicked(MouseEvent e) {
    		Point p = new Point(e.getX(), e.getY()); 
    		pointsModel.add(p);
    		pointsModel.clearSelected(); 
    		pointsModel.setSelected(p); 
    	}

    	public void mousePressed(MouseEvent e) {
    	}

    	public void mouseReleased(MouseEvent e) {
    	}

    	public void mouseEntered(MouseEvent e) {
    	}

    	public void mouseExited(MouseEvent e) {
    	}

    }

}
